"use strict";
exports.__esModule = true;
function forwardContext(name, options) {
    if (options === void 0) { options = {}; }
    var validator = options.validator;
    if (typeof validator !== 'function') {
        validator = function () { return null; };
    }
    var alias = typeof options.alias === 'string' ? options.alias : name;
    var hasDefault = 'defaultValue' in options || 'defaultGenerator' in options;
    var getDefault;
    if (hasDefault) {
        var defaultValue_1 = options.defaultValue;
        getDefault = typeof options.defaultGenerator === 'function'
            ? options.defaultGenerator
            : function () { return defaultValue_1; };
    }
    var mapToPropValue = typeof options.mapToProp === 'function' ? options.mapToProp : function (v) { return v; };
    var contextTypeInjector = function (setContextType) { return setContextType(name, validator); };
    var hasOwn = Object.prototype.hasOwnProperty;
    var propInjector = function (setProp, ownProp, ownContext) {
        if (ownContext && hasOwn.call(ownContext, name) && ownContext[name] !== undefined) {
            setProp(alias, mapToPropValue(ownContext[name]));
        }
        else if (hasDefault) {
            setProp(alias, mapToPropValue(getDefault(ownProp)));
        }
    };
    return { contextTypeInjector: contextTypeInjector, propInjector: propInjector };
}
exports["default"] = forwardContext;
